### Remote Control 1.10 (16.10.98)
### by LuNox (IRCNET; EMail: lunox@gmx.net, su1487@sx2.uni-dortmund.de)
## thanks to |ts| for testing and some suggestions :-) 
#
#==|Description|=============================================================
#
# The main purpose of this script is offering you commands to control
# your bot's via a botnet. Just look at the commands some lines below and
# you can imagine what this script does. ;-)
# 
# For more information use .rhelp.
# Another important command: .rlevel
#
#==|Commands/Features|=======================================================
# 
# LEVEL1: rchattr, rbotattr, rwhois, r+user, r-user, r+bot, r-bot, rcopy
#         r+host, r-host, rsave, rstatus, rchannel, rchaninfo 
# LEVEL2: rjoin, rjoinall, rpart, rpartall, rspy, rspystop, rspyinfo
# LEVEL3: rjump, rrehash, rrestart, rdie
# MISC  : rhelp, rlevel, rcheck, raccess, spy, spystop, spyinfo
#          
#==|Requirements|============================================================
#
# - Eggdrop 1.3.x
# - A botnet wouldn't be a bad idea. ;-)
#
# Only owners (+n) are able to use Remote Control.
#
#==|Misc|====================================================================
#
# I would be happy about comments, bug reports (ok, I wouldn't be happy
# about that ;-) ) or suggestions for further versions.
#
#==|History|==================================================================
#
#  1.10  16.10.98  Added rchaninfo
#		   Added rcopy
#		   Fixed security hole in rspy-functions
#  1.08  26.08.98  Added uptime calculation in rstatus	
#  1.07  25.08.98  Fixed some bugs in rjoin & !rjoin
#		   Fixed output errors in rstatus & rchannel
#  1.0   20.07.98  First release.   
#
#============================================================================
#----------------- DON'T CHANGE ANYTHING BELOW THIS LINE! -------------------
#============================================================================

set rver "1.10 (16.10.98)"
set rc "\002\[\002ReCo\002\]\002"
set l_channelfrom ""
set r_channelfrom ""
set l_spy_act "0"
set r_spy_act "0"
set rchannel_act "0"
set uet "1"

### dcc commands ###

bind dcc n rhelp rhelp_dcc
bind chon - * recoinfo

bind bot - report l_report
bind bot - sreport l_sreport

bind dcc n rlevel l_rlevel
bind dcc n raccess l_raccess

bind dcc n r+user l_r+user
bind bot - r+user r_r+user

bind dcc n r-user l_r-user
bind bot - r-user r_r-user

bind dcc n r+bot l_r+bot
bind bot - r+bot r_r+bot

bind dcc n r-bot l_r-bot
bind bot - r-bot r_r-bot

bind dcc n r+host l_r+host
bind bot - r+host r_r+host

bind dcc n r-host l_r-host
bind bot - r-host r_r-host

bind dcc n rwhois l_rwhois
bind bot - rwhois r_rwhois
bind bot - rwhois_ok l_rwhois_ok
bind bot - rwhois_okb l_rwhois_okb

bind dcc n rchattr l_rchattr
bind bot - rchattr r_rchattr

bind dcc n rbotattr l_rbotattr
bind bot - rbotattr r_rbotattr

bind bot - na l_no_access
bind bot - uef l_user_exists_false
bind bot - uet l_user_exists_true

bind dcc n rjoin l_rjoin_dcc
bind dcc n rjoinall l_rjoinall_dcc
bind dcc n rpart l_rpart_dcc
bind dcc n rpartall l_rpartall_dcc 

bind dcc n spy l_spy_on
bind dcc n spystop l_spy_off
bind dcc n spyinfo l_spy_info

bind dcc n rspy l_rspy_on
bind dcc n rspystop l_rspystop
bind dcc n rspyinfo l_rspyinfo
bind bot - rspy r_spy_on
bind bot - rspystop r_spy_off
bind bot - rspyinfo r_spy_info

bind dcc n rcheck l_rcheck
bind bot - rcheck r_rcheck
bind bot - rcheck_result l_rcheck_result

bind dcc n rjump l_rjump
bind bot - rjump r_rjump
bind bot - rjump_try l_rjump_try
bind bot - rjump_ok l_rjump_ok
bind bot - rjump_failed l_rjump_failed

bind dcc n rrehash l_rrehash
bind bot - rrehash r_rrehash

bind dcc n rrestart l_rrestart
bind bot - rrestart r_rrestart

bind dcc n rdie l_rdie
bind bot - rdie r_rdie

bind dcc n rsave l_rsave
bind bot - rsave r_rsave

bind dcc n rstatus l_rstatus
bind bot - rstatus r_rstatus
bind bot - rstatus_result l_rstatus_ok

bind dcc n rchannel l_rchannel
bind bot - rchannel r_rchannel
bind bot - rchannel_result l_rchannel_ok
bind bot - rchannel_init l_rchannel_init

bind dcc n rchaninfo l_rchaninfo
bind bot - rchaninfo r_rchaninfo
bind bot - rchaninfo_result l_rchaninfo_ok

bind dcc n rcopy l_rcopy
bind bot - rcopy r_rcopy

### pub commands ###

bind pub n !rjoin l_rjoin_pub
bind pub n !rjoinall l_rjoinall_pub
bind pub n !rpart l_rpart_pub
bind pub n !rpartall l_rpartall_pub

bind bot - rjoin r_rjoin
bind bot - rpart r_rpart

### msg commands ###

bind msg n rauth rauth
bind msg n rhelp rhelp_msg

### other ###

bind part n * deauth_part
bind join n * deauth_join
bind sign n * deauth_signoff


### Remote Control help ###

proc rhelp_dcc {nick idx arg} {
	global rver rc {botnet-nick}
	set hd "\#\#\# \002"
	set morehelp [lindex $arg 0]
	set morehelp [string tolower $morehelp]
	if {$morehelp == "rhelp"} {
		putdcc $idx "$hd rhelp \002"
		putdcc $idx "   Shows you the 'Remote Control' help."
	} elseif {$morehelp == "r+user"} {
		putdcc $idx "$hd r+user <bot> <nickname> \[hostmask\] \002"
		putdcc $idx "   Creates a new user record on the bot you've chosen with one hostmask, no password and the default flags of the remote bot."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "r-user"} {
		putdcc $idx "$hd r-user <bot> <nickname> \002"
		putdcc $idx "   Deletes the user record on the remote bot for the nickname given."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "r+bot"} {
		putdcc $idx "$hd r+bot <bot> <bot to add> <address:botport> <hostmask> \002"
		putdcc $idx "   Creates a new user record on the remote bot with the botflag (b). In opposition to +bot <hostmask> is mandatory. You can also specicy different ports for bots and users - enter <botport> as <botport/userport>, separated with a slash (/)."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "r-bot"} {
		putdcc $idx "$hd r-bot <bot> <bot to delete> \002"
		putdcc $idx "   Deletes bot record on the remote bot for the bot given."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "r+host"} {
		putdcc $idx "$hd r+host <bot> <nickname> <hostmask> \002"
                putdcc $idx "   Adds a hostmask to a user record on the remote bot."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "r-host"} {
		putdcc $idx "$hd r-bot <bot> <nickname> <hostmask>\002"
                putdcc $idx "   Deletes a hostmask from a user record on the remote bot."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "rwhois"} {
		putdcc $idx "$hd rwhois <bot> <nickname> \002"
		putdcc $idx "   Requests user information about the nickname given from the chosen bot." 
		putdcc $idx " "
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "rchannel"} {
		putdcc $idx "$hd rchannel <bot> <channel> \002"
		putdcc $idx "   Get channel stats via a remote bot." 
		putdcc $idx "   You can stop a running rchannel request by 'rchannel stop stop'."
		putdcc $idx " "
		putdcc $idx "   \002\Level 1 command\002"	
	} elseif {$morehelp == "rchattr"} {
		putdcc $idx "$hd rchattr <bot> <nickname> <+/-><flag(s)> \[channel\] \002"
		putdcc $idx "   Changes the global/channel attributes (flags) of the nickname given on the remote bot. See also .help whois to get more information about user attributes."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "rbotattr"} {
		putdcc $idx "$hd botattr <bot> <botnick> <+/-><flag(s)>"
		putdcc $idx "   Changes the bot attributes (flags) on the remote bot of the botnick given."
		putdcc $idx " "
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "rjoin"} {
		putdcc $idx "$hd rjoin <bot> <channel>"
		putdcc $idx "   Lets the remote bot join a channel you specified."
		putdcc $idx " "
		putdcc $idx "   \002\Level 2 command\002"
	} elseif {$morehelp == "rjoinall"} {
		putdcc $idx "$hd rjoinall <channel>"
		putdcc $idx "   Lets all bots join the channel you specified."
		putdcc $idx " "
		putdcc $idx "   \002\Level 2 command\002"
	} elseif {$morehelp == "rpart"} {
		putdcc $idx "$hd rpart <bot> <channel>"
		putdcc $idx "   Lets the remote bot leave the channel you specified."
		putdcc $idx " "
		putdcc $idx "   \002\Level 2 command\002"
	} elseif {$morehelp == "rpartall"} {
		putdcc $idx "$hd rpartall <channel> \[bot to stay\]"
		putdcc $idx "   Lets all bots leave the channel you specified. You may also choose a bot which shall stay on the channel."
		putdcc $idx " "
		putdcc $idx "   \002\Level 2 command\002"
	} elseif {$morehelp == "spy"} {
		putdcc $idx "$hd spy <channel to spy> <channel to put information>"
		putdcc $idx "   Activates the bot's spy mode. It will copy & paste all information it get's from the channel you've chosen to another channel."
	} elseif {$morehelp == "spystop"} {
		putdcc $idx "$hd spystop"
		putdcc $idx "   Stops spying immediately."
	} elseif {$morehelp == "spyinfo"} {
		putdcc $idx "$hd spyinfo"
		putdcc $idx "   Informs you about current spying."
	} elseif {$morehelp == "rspy"} {
		putdcc $idx "$hd rspy <bot> <channel to spy> <channel to put information>"
		putdcc $idx "   Activates the remote spy mode. The remote bot will copy & paste all information it get's from the channel you've chosen."
		putdcc $idx " "
		putdcc $idx "   \002\Level 2 command\002"
	} elseif {$morehelp == "rspystop"} {
		putdcc $idx "$hd rspystop <bot>"
		putdcc $idx "   Stops remote spying immediately."
		putdcc $idx " "
		putdcc $idx "   \002\Level 2 command\002"
	} elseif {$morehelp == "rspyinfo"} {
		putdcc $idx "$hd rspyinfo <bot>"
		putdcc $idx "   Informs you about current remote spying."
		putdcc $idx " "
		putdcc $idx "   \002\Level 2 command\002"
	} elseif {$morehelp == "rcheck"} {
		putdcc $idx "$hd rcheck"
		putdcc $idx "   Requests ${botnet-nick}\'s access to the bots connected to the botnet."
		putdcc $idx "   Level 1 access: rchattr, rbotattr, rwhois, r+user, r-user, rcopy,"
		putdcc $idx "                   r+bot, r-bot, r+host, r-host, rstatus, rchaninfo,"                 
		putdcc $idx "                   rsave, rchannel"
		putdcc $idx "   Level 2 access: rjoin, rjoinall, rpart, rpartall, rspy, rspystop, rspyinfo"
		putdcc $idx "   Level 3 access: rjump, rrehash, rrestart, rdie"
	} elseif {$morehelp == "rjump"} {
		putdcc $idx "$hd rjump <bot> <server to jump to>"
		putdcc $idx "   Lets the remote bot jump to a chosen server. If the jump request fails the bot tries to reconnect to its 'old' server."	
		putdcc $idx "   \002\Level 3 command\002"
	} elseif {$morehelp == "rrehash"} {
		putdcc $idx "$hd rrehash <bot>"
		putdcc $idx "   Lets the remote bot rehash."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 3 command\002"
	} elseif {$morehelp == "rrestart"} {
		putdcc $idx "$hd rrestart <bot>"
		putdcc $idx "   Lets the remote bot restart."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 3 command\002"
	} elseif {$morehelp == "rrehash"} {
		putdcc $idx "$hd rdie <bot>"
		putdcc $idx "   Lets the remote bot shut down."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 3 command\002"
	} elseif {$morehelp == "rsave"} {
		putdcc $idx "$hd rsave <bot>"
		putdcc $idx "   Lets the remote bot save its userfile."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "raccess"} {
		putdcc $idx "$hd raccess"
		putdcc $idx "   Shows you the access levels of other bots to ${botnet-nick}."
		putdcc $idx "   Level 1 access: rchattr, rbotattr, rwhois, r+user, r-user, rcopy,"
		putdcc $idx "                   r+bot, r-bot, r+host, r-host, rstatus, rchaninfo,"                 
		putdcc $idx "                   rsave, rchannel"
		putdcc $idx "   Level 2 access: rjoin, rjoinall, rpart, rpartall, rspy, rspystop, rspyinfo"
		putdcc $idx "   Level 3 access: rjump, rrehash, rrestart, rdie"
	} elseif {$morehelp == "rstatus"} {
		putdcc $idx "$hd rstatus"
		putdcc $idx "   Requests current status of another bot (server, channels, etc.)."
		putdcc $idx " "
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "rlevel"} {
		putdcc $idx "$hd rlevel <+/-><flag(s)>"
		putdcc $idx "   This is the most important command of \002\ReCo\002."
		putdcc $idx "   You may work with the flags 1, 2 and 3. Each flag stands for an access level. You'll have to set these for the bot which should be allowed to control ${botnet-nick}." 
		putdcc $idx " "
		putdcc $idx "   Example: You want to control BotB using BotA. Set the access levels for BotA on BotB."
		putdcc $idx " "
		putdcc $idx "            on BotB: \002\.rlevel BotA +123\002"
		putdcc $idx " "
		putdcc $idx "            Now BotA should have Level 1, Level 2 and Level 3" 
		putdcc $idx "            access to BotB."
		putdcc $idx " "
		putdcc $idx "            You can check your settings" 
		putdcc $idx "            on BotB: \002\.raccess\002" 
		putdcc $idx "            on BotA: \002\.rcheck\002"
		putdcc $idx " "
		putdcc $idx "   Level 1 access: rchattr, rbotattr, rwhois, r+user, r-user, rcopy,"
		putdcc $idx "                   r+bot, r-bot, r+host, r-host, rstatus, rchaninfo, "                 
		putdcc $idx "                   rsave, rchannel"
		putdcc $idx "   Level 2 access: rjoin, rjoinall, rpart, rpartall, rspy, rspystop, rspyinfo"
		putdcc $idx "   Level 3 access: rjump, rrehash, rrestart, rdie"
	} elseif {$morehelp == "rchanset"} {
		putdcc $idx "$hd rchanset <bot> <channel> <settings> \002\(not available yet)\002"
		putdcc $idx "   Sets channel settings remotely."
		putdcc $idx " "
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "rcopy"} {
		putdcc $idx "$hd rcopy <bot> <handle to copy>"
		putdcc $idx "   Copies a user/bot from this bot to another one."
		putdcc $idx " "
		putdcc $idx "   This command works also global (use * for <bot>)."
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == "rchaninfo"} {
		putdcc $idx "$hd rchaninfo <bot> <channel>"
		putdcc $idx "   Requests chaninfo about a channel from another bot."
		putdcc $idx " "
		putdcc $idx "   \002\Level 1 command\002"
	} elseif {$morehelp == ""} {
		putdcc $idx "\002\[\002\ReCo\002\] Remote Control $rver\002 for eggdrop 1.3.x by LuNox"
		putdcc $idx "$rc   For the progressive and comfortable bot owner... ;-)"
		putdcc $idx "$rc"
		putdcc $idx "$rc DCC COMMANDS AVAILABLE:"
		putdcc $idx "$rc"
		putdcc $idx "$rc  LEVEL 1 REMOTE COMMANDS"
		putdcc $idx "\002\[\002\ReCo\002\]   rchattr     rbotattr    rwhois      r+user      r-user\002"
     		putdcc $idx "\002\[\002\ReCo\002\]   r+bot       r-bot       r+host      r-host      rcopy\002"
     		putdcc $idx "\002\[\002\ReCo\002\]   rstatus     rchannel    rsave       rchaninfo\002"
		putdcc $idx "$rc"
		putdcc $idx "$rc  LEVEL 2 REMOTE COMMANDS"
		putdcc $idx "\002\[\002\ReCo\002\]   rjoin       rjoinall    rpart       rpartall\002"
		putdcc $idx "\002\[\002\ReCo\002\]   rspyinfo    rspy        rspystop\002"
		putdcc $idx "$rc"
		putdcc $idx "$rc  LEVEL 3 REMOTE COMMANDS"
		putdcc $idx "\002\[\002\ReCo\002\]   rjump       rrehash     rrestart    rdie\002"
		putdcc $idx "$rc"
		putdcc $idx "$rc  MISC COMMANDS"
		putdcc $idx "\002\[\002\ReCo\002\]   rhelp       rlevel      rcheck      raccess\002"
		putdcc $idx "\002\[\002\ReCo\002\]   spyinfo     spy         spystop\002"
		putdcc $idx "$rc"
		putdcc $idx "$rc Get more information with .rhelp <command>"
	} else {
		putdcc $idx "$rc I don't know $morehelp. Try .rhelp."
	} 
	return 1
}

proc rhelp_msg {nick userhost handle arg} {
	global botnick rver rc
        set hdmsg "\002\MSG\002"
	set morehelp [lindex $arg 0]
	set morehelp [string tolower $morehelp]
	if {$morehelp == "rhelp"} {
		putserv "NOTICE $nick :$rc $hdmsg $botnick \002\RHELP\002"
       		putserv "NOTICE $nick :$rc    Shows you the Remote Control /MSG-help."
	} elseif {$morehelp == "rauth"} {
		putserv "NOTICE $nick :$rc $hdmsg $botnick \002\RAUTH\002 <password>"
		putserv "NOTICE $nick :$rc    Authenticates yourself to the bot."  
	} elseif {$morehelp == "!rjoin"} {
		putserv "NOTICE $nick :$rc $hdmsg $botnick \002\!RJOIN\002 <bot> \[channel]\"
		putserv "NOTICE $nick :$rc    Requests a bot to join the channel. The bot has to be connected to the botnet. If no channel specified the current channel will be taken."
	} elseif {$morehelp == "!rjoinall"} {
		putserv "NOTICE $nick :$rc $hdmsg $botnick \002\!RJOINALL \[channel]\\002"
		putserv "NOTICE $nick :$rc    Informs all available bots to join the channel. The bots have to be connected to the botnet. If no channel specified the current channel will be taken."
	} elseif {$morehelp == "!rpart"} {
		putserv "NOTICE $nick :$rc $hdmsg $botnick \002\!RPART\002 <bot> \[channel]\"
		putserv "NOTICE $nick :$rc    Lets the bot leave the channel. If no channel specified the current channel will be taken."
	} elseif {$morehelp == "!rpartall"} {
		putserv "NOTICE $nick :$rc $hdmsg $botnick \002\!RPARTALL\002 \[bot\] \[channel]\"
		putserv "NOTICE $nick :$rc    Informs all bots to leave the channel. You may specify a bot which should stay on the channel. If no channel specified the current channel will be taken."
	} elseif {$morehelp == ""} {
		putserv "NOTICE $nick :\002\[\002\ReCo\002\] Remote Control $rver\002 by LuNox"
		putserv "NOTICE $nick :$rc \002\MSG\002 and \002\(!)PUBLIC\002 commands \002"
		putserv "NOTICE $nick :$rc"
		putserv "NOTICE $nick :$rc      RHELP     RAUTH"
		putserv "NOTICE $nick :$rc      !RJOIN    !RJOINALL"
		putserv "NOTICE $nick :$rc      !RPART    !RPARTALL"
		putserv "NOTICE $nick :$rc"
		putserv "NOTICE $nick :$rc For help on a command, $hdmsg $botnick \002\RHELP\002 <command>"
		putserv "NOTICE $nick :$rc More commands are available via dcc chat."
	} else {
		putserv "NOTICE $nick :$rc I don't know $morehelp. Try /msg $botnick rhelp."
	}
	return 1
}

proc recoinfo {nick idx} {
	global rver 
	putdcc $idx " "
	putdcc $idx "This bot is equipped with \002\Remote Control $rver\002" 
	putdcc $idx " "
}

### general procedures ###

proc bot_av {nick} {
	set bt_av "0"
	if {[lsearch [string tolower [bots]] [string tolower $nick]] != "-1"} {
	    set bt_av "1"
        }
	return $bt_av
}

proc bot_nc {idx whichbot} {
	putdcc $idx "\002\[\002\ReCo\002\]\002 $whichbot is not connected to the botnet."
}
	
proc l_no_access {nick idx arg} {
        set idx_req [lindex $arg 0]
        set what [lindex $arg 1]
        putdcc $idx_req "\002\[\002\ReCo\002\]\002 \{\002$nick\002\}: You aren't allowed to execute $what."
}

proc l_user_exists_false {nick idx arg} {
        set idx_req [lindex $arg 0]
        set whichuser [lindex $arg 1]
        putdcc $idx_req "\002\[\002\ReCo\002\]\002 \{\002$nick\002\}: $whichuser doesn't exist."
}

proc l_user_exists_true {nick idx arg} {
        set idx_req [lindex $arg 0]
        set whichuser [lindex $arg 1]
        putdcc $idx_req "\002\[\002\ReCo\002\]\002 \{\002$nick\002\}: $whichuser already exists."
}

proc getflags {nick chan} {
	if {$chan == ":"} {
	    set uflags [chattr $nick]
	} else {
	    set uflags [chattr $nick $chan]
	}
	return $uflags
}

proc getlflags {nick} {
        set lflags [getuser $nick XTRA rlevel]
        return $lflags
}

proc getbotflags {nick chan} {
        if {!$chan} {
	    set bflags [botattr $nick]
        } else {
	    set bflags [botattr $nich $chan]
	}
	return $bflags
}

proc l1flag {nick} {
	set lflags [getlflags $nick]
	if {[string match "*1*" $lflags]} {
	    return "1"
	} else {
	    return "0"
	}
}

proc l2flag {nick} {
	set lflags [getlflags $nick]
	if {[string match "*2*" $lflags]} {
	    return "1"
	} else {
	    return "0"
	}
}

proc l3flag {nick} {
	set lflags [getlflags $nick]
	if {[string match "*3*" $lflags]} {
	    return "1"
	} else {
	    return "0"
	}
}

proc raflag {nick} {
	if {[getuser $nick XTRA rauth] == "1"} {
	    return "1"
	} else {
	    return "0"
	}
}


proc l_report {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set report [lrange $arg 1 end]
	if {[valididx $idx_req] && [matchattr [idx2hand $idx_req] n]} {
	    putdcc $idx_req "$rc \{\002$nick\002\}: $report"
	}
}

proc l_sreport {nick idx arg} {
	global rc
	set schannel [lindex $arg 0]
	set report [lrange $arg 1 end]
	if {[validchan $schannel]} {
	    putserv "PRIVMSG $schannel :$report"
	}
}


### remote +user ###

proc l_r+user {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set umask [lindex $arg 2]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {($whichbot == "") || ($whichuser == "") || ($umask == "")} {
		putdcc $idx "Usage: .r+user <bot> <nickname> <hostmask>"
		return 0
	} else {
	    if {$whichbot != "*"} {    
		if {[bot_av $whichbot]} {
		    putbot $whichbot "r+user $idx $whichuser $umask $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "r+user $idx $whichuser $umask $nick"
		return 1
	    }
	}
}

proc r_r+user {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set umask [lindex $arg 2]
	set doneby [lindex $arg 3]
	if {[validuser $whichuser]} {
		putbot $nick "uet $idx_req $whichuser"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req r+user"
		putlog "$rc $doneby@$nick tried r+user of $whichuser ($umask)"
	} else {	
	    	adduser $whichuser $umask
		set uflags [getflags $whichuser ":"]
		putbot $nick "report $idx_req r+user of $whichuser with the flag(s) $uflags successful."
                putlog "$rc User $whichuser ($umask) added to my userlist with the flag(s) $uflags by $doneby@$nick"
                return 0
	}
}

### remote -user ###

proc l_r-user {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichuser [lindex $arg 1]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {($whichbot == "") || ($whichuser == "")} {
		putdcc $idx "Usage: .r-user <bot> <nickname>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "r-user $idx $whichuser $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
	    	putallbots "r-user $idx $whichuser $nick"
		return 1
	    }
	}
}

proc r_r-user {nick idx arg} {
	global rc botnick {botnet-nick}
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set doneby [lindex $arg 2]
	if {![validuser $whichuser]} {
		putbot $nick "uef $idx_req $whichuser"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req r-user"
		putlog "$rc $doneby@$nick tried r-user on this bot"
	} elseif {[matchattr $whichuser n]} {
		putbot $nick "report $idx_req You aren't allowed to delete $whichuser (owner)."
		putlog "$rc $doneby@$nick tried to delete $whichuser (owner)" 
	} else {	
	deluser $whichuser
	putbot $nick "report $idx_req r-user of $whichuser successful" 
	putlog "$rc User $whichuser has been deleted from my userlist by $doneby@$nick"
	return 0
	}
}


### remote +host ###

proc l_r+host {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set umask [lindex $arg 2]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {($whichbot == "") || ($whichuser == "") || ($umask == "")} {
		putdcc $idx "Usage: .r+host <bot> <nickname> <hostmask>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "r+host $idx $whichuser $umask $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "r+host $idx $whichuser $umask $nick"
		return 1
	    }
	}	
}

proc r_r+host {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set umask [lindex $arg 2]
	set doneby [lindex $arg 3]
	if {![validuser $whichuser]} {
		putbot $nick "uef $idx_req $whichuser"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req r-host"
		putlog "$rc $doneby@$nick tried r+host ($umask) of $whichuser."
	} else {	
		set het "0"
		foreach h [getuser $whichuser HOSTS] {
		    if {[string tolower $h] == [string tolower $umask]} {		    
			set het "1"
		    }
		}
		if {!$het} {
		    setuser $whichuser hosts $umask
		    putbot $nick "report $idx_req r+host on $whichuser successful, added hostmask $umask."
            	    putlog "$rc Hostmask $umask added to $whichuser by $doneby@$nick."
            	    return 0
		} else {
		    putbot $nick "report $idx_req r+host ($umask) on $whichuser failed. Hostmask $umask already exists."
            	    putlog "$rc $doneby@$nick tried to add existent hostmask $umask from $whichuser."
            	    return 0
		}
	}
}

### remote -host ###

proc l_r-host {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set umask [lindex $arg 2]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {($whichbot == "") || ($whichuser == "") || ($umask == "")} {
		putdcc $idx "Usage: .r-host <bot> <nickname> <hostmask>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "r-host $idx $whichuser $umask $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}	
	    } else {
		putallbots "r-host $idx $whichuser $umask $nick"
		return 1
	    }
	}
}

proc r_r-host {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set umask [lindex $arg 2]
	set doneby [lindex $arg 3]
	if {![validuser $whichuser]} {
		putbot $nick "uef $idx_req $whichuser"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req r-host"
		putlog "$rc $doneby@$nick tried r-host on this bot."
	} else {	
	    set h_true [delhost $whichuser $umask]
	    if {$h_true} {
		putbot $nick "report $idx_req r-host ($umask) on $whichuser successful." 
		putlog "$rc Removed $umask from $whichuser by $doneby@$nick."
		return 0
	    } else {
		putbot $nick "report $idx_req r-host ($umask) on $whichuser failed. Hostmask $umask doesn't exist." 
		putlog "$rc $doneby@$nick tried to remove non-existent hostmask $umask from $whichuser."
		return 0
	    }
	}
}

### remote +bot ###

proc l_r+bot {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichbot_add [lindex $arg 1]
	set botserver [lindex $arg 2]
	set botmask [lindex $arg 3]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {($whichbot == "") || ($whichbot_add == "") || ($botserver == "") || ($botmask == "")} {
		putdcc $idx "Usage: .r+bot <bot> <bot to add> <address:botport> <hostmask>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "r+bot $idx $whichbot_add $botserver $botmask $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "r+bot $idx $whichbot_add $botserver $botmask $nick"
		return 1
	    }
	}		
}

proc r_r+bot {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichbot_add [lindex $arg 1]
	set botserver [lindex $arg 2]
	set botmask [lindex $arg 3]
	set doneby [lindex $arg 4]
	if {[validuser $whichbot_add]} {
		putbot $nick "uet $idx_req $whichbot_add"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req r+bot"
		putlog "$rc $doneby@$nick tried r+bot of $whichbot_add ($botmask)."
	} else {	
		addbot $whichbot_add $botserver
		setuser $whichbot_add HOSTS $botmask
		set uflags [getflags $whichbot_add ":"]
		putbot $nick "report $idx_req r+bot of $whichbot_add with the flag(s) $uflags successful." 
		putlog "$rc Bot $whichbot_add ($botserver, $botmask) added to my userlist with the flag(s) $uflags by $doneby@$nick"
		return 0
	}
}

### remote -bot ###

proc l_r-bot {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichbot_del [lindex $arg 1]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {($whichbot == "") || ($whichbot_del == "")} {
		putdcc $idx "Usage: .r-user <bot> <bot to delete>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "r-bot $idx $whichbot_del $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "r-bot $idx $whichbot_del $nick"
		return 1	
	    }
	}
}

proc r_r-bot {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichbot_del [lindex $arg 1]
	set doneby [lindex $arg 2]
	if {![validuser $whichbot_del]} {
		putbot $nick "uef $idx_req $whichuser"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req r-bot"
		putlog "$rc $doneby@$nick tried r-bot on this bot"
	} elseif {[matchattr $whichbot_del n]} {
		putbot $nick "report $idx_req You aren't allowed to delete $whichbot_del (owner flag!)"
		putlog "$rc $doneby@$nick tried to delete $whichbot_del (owner flag!)" 
	} else {	
	deluser $whichbot_del
	putbot $nick "report $idx_req r-bot of $whichbot_del successful." 
	putlog "$rc Bot $whichbot_del has been deleted from my userlist by $doneby@$nick."
	return 0
	}
}

### remote whois ###

proc l_rwhois {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichuser [lindex $arg 1]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {($whichbot == "") || ($whichuser == "")} {
		putdcc $idx "Usage: .rwhois <bot> <handle>"
		return 0
	} else {
	if {[bot_av $whichbot]} {
		putbot $whichbot "rwhois $idx $whichuser $nick"
		return 1
	} else {
		bot_nc $idx $whichbot
		}
	}		
}

proc r_rwhois {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set doneby [lindex $arg 2]
	if {![validuser $whichuser]} {
		putbot $nick "uef $idx_req $whichuser"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req rwhois"
		putlog "$rc $doneby@$nick tried rwhois on $whichuser."
	} else {	
		if {[matchattr $whichuser b]} {
		    set tmp ""
		    set bflags [botattr $whichuser]
		    if {$bflags == ""} {set bflags "-"}
		    append bflags ","
		    foreach ch [channels] {
			set bflagsc [botattr $whichuser $ch]
			if {$bflagsc != "|-|" && [string match "*s*" $bflagsc]} {
			    append bflags "$ch,"
			}
		    }
		    set tmp ""
		    set binfo [getuser $whichuser BOTADDR]
		    foreach bhost [getuser $whichuser HOSTS] {
			append tmp $bhost
			append tmp ","
		    }
		    if {$tmp == ""} {
			set bhosts "-,"
		    } else {
			set bhosts $tmp
		    }
		    set uflags [getflags $whichuser ":"]
		    append uflags ","
		    foreach ch [channels] {
			set uflagsc [chattr $whichuser $ch]
			if {$uflagsc != ""} {
			    set i [string first "|" $uflagsc]
			    set tmp [string range $uflagsc [expr $i + 1] end]
			    append uflags "$ch,$tmp,"
			}
		    }
		    putbot $nick "rwhois_okb $idx_req $whichuser $bflags $binfo $bhosts $uflags" 
		    putlog "$rc rwhois on $whichuser by $doneby@$nick successful"
		    return 0
		} else {    
		    set tmp ""
		    foreach uhost [getuser $whichuser HOSTS] {
			append tmp $uhost
			append tmp ","
		    }
		    if {$tmp == ""} {
			set uhosts "-,"
		    } else {
			set uhosts $tmp
		    }
		    set uflags [getflags $whichuser ":"]
		    append uflags ","
		    foreach ch [channels] {
			set uflagsc [chattr $whichuser $ch]
			if {$uflagsc != ""} {
			    set i [string first "|" $uflagsc]
			    set tmp [string range $uflagsc [expr $i + 1] end]
			    append uflags "$ch,$tmp,"
			}
		    }
		    putbot $nick "rwhois_ok $idx_req $whichuser $uhosts $uflags" 
		    putlog "$rc rwhois on $whichuser by $doneby@$nick successful"
		    return 0
		}
	}
}
	
proc l_rwhois_okb {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set bflags_r [lindex $arg 2]
	set binfo_s [lindex $arg 3]
	set binfo_bp [lindex $arg 4]
	set binfo_up [lindex $arg 5]
	set uhosts_r [lindex $arg 6]
        set uflags_r [lrange $arg 7 end]
	set bflags ""
	set uflags ""
	putdcc $idx_req "$rc Remote whois summary of $whichuser@$nick:"
	putdcc $idx_req "$rc --------------------------------------------"
	putdcc $idx_req "$rc Entry type: Bot" 
	putdcc $idx_req "$rc Handle    : $whichuser"
	putdcc $idx_req "$rc Host(s)   : [return_uhosts $uhosts_r]"
	putdcc $idx_req "$rc Bot adress: $binfo_s"
	putdcc $idx_req "$rc     Telnet: $binfo_bp"
	putdcc $idx_req "$rc      Relay: $binfo_up"
	putdcc $idx_req "$rc Flags"
	for {set i 0} {$i < [string first "," $uflags_r]} {incr i} {
	    if {![string match "," [string index $uflags_r $i]]} {
		append uflags [string index $uflags_r $i]
	    }
	}
	putdcc $idx_req "$rc     global: $uflags"
	return_ch_flags $idx_req $uflags_r
	for {set i 0} {$i < [string first "," $bflags_r]} {incr i} {
	    if {![string match "," [string index $bflags_r $i]]} {
		append bflags [string index $bflags_r $i]
	    }
	}
	putdcc $idx_req "$rc Botflags : $bflags"
	for {set i [expr {[string first "," $bflags_r] + 1}]} {$i < [string length $bflags_r]} {incr i} {
	    if {![string match "," [string index $bflags_r $i]]} {
		append bflags_c [string index $bflags_r $i]
	    } else {
		putdcc $idx_req "$rc    shared: $bflags_c"
		set bflags_c ""
	    }
	}
}

proc l_rwhois_ok {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set uhosts_r [lindex $arg 2]
        set uflags_r [lrange $arg 3 end]
	putdcc $idx_req "$rc Remote whois summary of $whichuser@$nick:"
	putdcc $idx_req "$rc --------------------------------------------"
	putdcc $idx_req "$rc Entry type: User"
	putdcc $idx_req "$rc Handle    : $whichuser"
	putdcc $idx_req "$rc Host(s)   : [return_uhosts $uhosts_r]"
	putdcc $idx_req "$rc Flags"
	for {set i 0} {$i < [string first "," $uflags_r]} {incr i} {
	    if {![string match "," [string index $uflags_r $i]]} {
		append uflags [string index $uflags_r $i]
	    }
	}
	putdcc $idx_req "$rc     global: $uflags"
	return_ch_flags $idx_req $uflags_r 
}

proc return_ch_flags {idx_req uflags_r} {
	global rc
	set uflags ""
	set uflags_c ""
	set j "0"
	for {set i [expr {[string first "," $uflags_r] + 1}]} {$i < [string length $uflags_r]} {incr i} {
	    if {![string match "," [string index $uflags_r $i]]} {
		if {!$j} {
		    append uflags_c [string index $uflags_r $i]
		} else {
		    append uflags [string index $uflags_r $i]
		}
	    } else {
		if {!$j} {
		    set j "1"
		} else {
		    if {$uflags != "-"} {
			putdcc $idx_req "$rc    channel: $uflags ($uflags_c)"
		    }
		    set uflags ""
		    set uflags_c ""
		    set j "0"
		}
	    }
	}
}

proc return_uhosts {uhosts_r} {
	set uhosts ""
	for {set i 0} {$i < [string length $uhosts_r]} {incr i} {
	    if {![string match "," [string index $uhosts_r $i]]} {
		append uhosts [string index $uhosts_r $i]
	    } else {
		if {[expr {[string length $uhosts_r] - $i}] > 1} {
		    append uhosts ", "
		}
	    }
	}
	return $uhosts
}

### remote chattr ###

proc l_rchattr {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set sflags [lindex $arg 2]
	set whichchan [lindex $arg 3]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {($whichbot == "") || ($whichuser == "") || ($sflags =="")} {
		putdcc $idx "Usage: .rchattr <bot> <handle> <+/-><flag(s)> \[channel\]"
		return 0
		}
        if {![bot_av $whichbot]} {
		bot_nc $idx $whichbot
		return 0
	}
	if {[string match "*n*" $sflags]} {
		putdcc $idx "$rc Owner-flag (+n) mustn't be set remotely."
		return 0
		}
	if {[string match "\[+-\]*" $sflags]} {
		for {set i 1} {$i < [string length $sflags]} {incr i} {
		    if {![string match "*\[omtxjpcubdkfvahA-Z0-9\]*" [string index $sflags $i]]} {
			putdcc $idx "$rc Invalid flag(s) - rchattr aborted! Use \002.help whois\002 to get information about valid flags."
			return 0
		    }
		}
	} else {
		putdcc $idx "$rc Flags have to begin with '+' or '-'!"
		putdcc $idx "Usage: .rchattr <bot> <handle> <+/-><flag(s)> \[channel\]"
		return 0
	}
	if {![validuser $whichbot] && ($whichbot != "*")} {
                putdcc $idx "$rc I don't know $whichbot - rchattr aborted!"
                return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "rchattr $idx $whichuser $sflags $nick $whichchan"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "rchattr $idx $whichuser $sflags $nick $whichchan"
		return 1
	    }		
	}
}

proc r_rchattr {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set sflags [lindex $arg 2]
	set doneby [lindex $arg 3]
	set whichchan [lindex $arg 4]
	if {![validuser $whichuser]} {
		putbot $nick "uef $idx_req $whichuser"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req rchattr"
		putlog "$rc $doneby@$nick tried rchattr ($sflags) on $whichuser."
	} elseif {($whichchan != "") && ![validchan $whichchan]} {
		putbot $nick "report $idx_req $whichchan isn't a valid channel - rchattr aborted."
	} else {	
		if {$whichchan != ""} {
		    set tmp "-|"
		    append tmp $sflags
		    chattr $whichuser $tmp $whichchan
		    set uflags [getflags $whichuser $whichchan]
		    set i [string first "|" $uflags]
		    set tmp [string range $uflags 0 [expr $i - 1]]
		    set tmp2 [string range $uflags [expr $i + 1] end]
		    if {$tmp != "-"} {
			set tmp3 "+"
			append tmp3 $tmp
			set tmp $tmp3
		    }
		    if {$tmp2 != "-"} {
			set tmp3 "+"
			append tmp3 $tmp2
			set tmp2 $tmp3
		    }
		    putbot $nick "report $idx_req Global flags for $whichuser are now $tmp." 
		    putbot $nick "report $idx_req Channel flags for $whichuser on $whichchan are now $tmp2 (requested: $sflags)." 
		    putlog "$rc rchattr on $whichuser by $doneby@$nick successful (flags for $whichchan requested/now : $sflags/$tmp2)."
		} else {
		    chattr $whichuser $sflags
		    set uflags [getflags $whichuser ":"]
		    putbot $nick "report $idx_req Global flags for $whichuser are now +$uflags (requested: $sflags)." 
		    putlog "$rc rchattr on $whichuser by $doneby@$nick (global flags requested/now : $sflags/$uflags)."
		    return 0
		}
	}
}

### remote botattr ###

proc l_rbotattr {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichbot_change [lindex $arg 1]
	set sflags [lindex $arg 2]
	set whichchan [lindex $arg 3]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {($whichbot == "") || ($whichbot_change == "") || ($sflags =="")} {
		putdcc $idx "Usage: .rbotattr <bot> <handle> <+/-><flag(s)> \[channel\]"
		return 0
	}
	if {[string length $sflags] > 2} {
		putdcc $idx "$rc You may only set \002\one\002 bot attribute at one time."
		return 0
	}
	if {[string match \[+-\]* $sflags]} {
		for {set i 1} {$i < [string length $sflags]} {incr i} {
		    if {![string match "*\[sphalr0-9\]*" [string index $sflags $i]]} {
			putdcc $idx "$rc Invalid flag(s) - rbotattr aborted! Use \002.help whois\002 to get information about valid flags."
			return 0
		    }
		}
	} else {
		putdcc $idx "$rc Flags have to begin with '+' or '-'!"
		putdcc $idx "Usage: .rbotattr <bot> <handle> <+/-><flag(s)> \[channel\]"
		return 0
	}
	if {[bot_av $whichbot]} {
		if {($whichchan != "") && ([string match "*s*" $sflags])} {
		    putbot $whichbot "rbotattr $idx $whichbot_change $sflags $nick $whichchan"
		    return 1
		} else {
		    putbot $whichbot "rbotattr $idx $whichbot_change $sflags $nick"
		    return 1
		}
	} else {
		bot_nc $idx $whichbot
	}
}

proc r_rbotattr {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichbot_change [lindex $arg 1]
	set sflags [lindex $arg 2]
	set doneby [lindex $arg 3]
	set whichchan [lindex $arg 4]
	if {![validuser $whichbot_change]} {
		putbot $nick "uef $idx_req $whichbot_change"
	} elseif {![l1flag $nick]} {
		putbot $nick "na $idx_req rbotattr"
		putlog "$rc $doneby@$nick tried rbotattr ($sflags) on $whichbot_change."
	} elseif {![matchattr $whichbot_change b]} {
		putbot $nick "report $idx_req handle $whichbot is NO bot - rbotattr aborted!"
	} elseif {($whichchan != "") && ![validchan $whichchan]} {
		putbot $nick "report $idx_req $whichchan isn't a valid channel - rbotattr aborted."
	} else {
		if {$whichchan != ""} {
		    set tmp "-|"
		    append tmp $sflags
		    botattr $whichbot_change $tmp $whichchan
		    set botflags [getbotflags $whichbot_change $whichchan]
		    set i [string first "|" $uflags]
		    set tmp [string range $botflags 0 [expr $i - 1]]
		    set tmp2 [string range $botflags [expr $i + 1] end]
		    if {$tmp != "-"} {
			set tmp3 "+"
			append tmp3 $tmp
			set tmp $tmp3
		    }
		    if {$tmp2 != "-"} {
			set tmp3 "+"
			append tmp3 $tmp2
			set tmp2 $tmp3
		    }
		    putbot $nick "report $idx_req Global botflags for $whichbot_change are now $tmp." 
		    putbot $nick "report $idx_req Channel botflags for $whichbot_change on $whichchan are now $tmp2 (requested: $sflags)." 
		    putlog "$rc botattr on $whichbot_change by $doneby@$nick (flags for $whichchan requested/now : $sflags/$tmp2)."
		} else {
		    botattr $whichbot_change $sflags
		    set botflags [getbotflags $whichuser 0]
		    putbot $nick "report $idx_req Global botflags for $whichbot_change are now +$uflags (requested: $sflags)." 
		    putlog "$rc rbotattr on $whichbot_change by $doneby@$nick (global flags requested/now : $sflags/$uflags)."
		    return 0
		}	
	}
}

### Remote join ###

proc l_rjoin_pub {nick umask handle channel arg} {
        global botnick {botnet-nick} rc
	set whichbot [lindex $arg 0]
        set whichchan [lindex $arg 1]
	if {$whichchan == ""} {set whichchan $channel}
	if {![raflag $handle]} {
		putserv "NOTICE $nick :$rc You will have to authenticate first. Usage: /msg $botnick rauth <pwd>"
	} elseif {![bot_av $whichbot] && ([string tolower $whichbot] != || [string tolower $botnick])} {
		putserv "NOTICE $nick :$rc $whichbot isn't connected to the botnet."
	} elseif {[validchan $whichchan] && [onchan $whichbot $whichchan]} {
		putserv "NOTICE $nick :$rc $whichbot is already on $whichchan. Open your eyes! :-)"
	} else {
		if {[string tolower $whichbot] == [string tolower $botnick]} {
		    channel add $whichchan
		    putlog "\002\[\002\ReCo\002\]\002 rjoin requested by $doneby@$channel for $chan. 
		} else {
		    putbot $whichbot "rjoin $whichchan $handle"
        	    return 1
		}
	}
}

proc l_rjoin_dcc {hand idx arg} {
        global botnick {botnet-nick} rc
        set whichbot [lindex $arg 0]
        set channel [lindex $arg 1]
	if {($whichbot == "") || ($channel == "")} {
		putdcc $idx "Usage: .rjoin <bot> <channel>"
	} elseif {![bot_av $whichbot]} {
                putdcc $idx "$rc $whichbot isn't connected to the botnet."
        } elseif {[validchan $channel]} { 
		if {[onchan $whichbot $channel]} {
                	putdcc $idx "$rc $whichbot is already on $channel. Open your eyes! :-)"
		}
        } else {
                putbot $whichbot "rjoin $channel $hand"
        	return 1
	}
}

proc r_rjoin {nick idx arg} {
	set chan [lindex $arg 0]
	set doneby [lindex $arg 1]
	if {[l2flag $nick]} {
		if {![validchan $chan]} {
			channel add $chan
		}
		putlog "\002\[\002\ReCo\002\]\002 rjoin requested by $doneby@$nick for $chan."
 	}
}

### Remote joinall ###

proc l_rjoinall_pub {nick umask handle channel arg} {
	global botnick {botnet-nick}
	set whichchan [lindex $arg 0]
	if {$whichchan == ""} {set whichchan $channel}
	if {![raflag $handle]} {
		putserv "NOTICE $nick :\002\[\002\ReCo\002\]\002 You will have to authenticate first. Usage: /msg $botnick rauth <pwd>"
	} else {
	foreach bt [bots] {
		if {![validchan $whichchan]} {
			channel add $whichchan
		}
		if {[validchan $whichchan] && ![onchan $bt $whichchan]} {
			putbot $bt "rjoin $whichchan $handle"
		} elseif {![validchan $whichchan]} {
			putallbots "rjoin $whichchan $handle"
		}
	}
	return 1
	}
}

proc l_rjoinall_dcc {hand idx arg} {
        global botnick {botnet-nick}
        set channel [lindex $arg 0]
	if {$channel == ""} {
		putdcc $idx "Usage: .rjoinall <channel>"
	} else {
		if {![validchan $channel]} {
			channel add $channel
		}
		foreach bt [bots] {
                	if {![onchan $bt $channel]} {
                        	putbot $bt "rjoin $channel $hand"
                	} elseif {![validchan channel]} {
			    putallbots "rjoin $channel $handle"
			}
        	}
	return 1
        }
}


### Part channel ###

proc l_rpart_pub {nick umask handle channel arg} {
	global botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichchan [lindex $arg 1]
	if {$whichchan == ""} {set whichchan $channel} 
	if {[raflag $handle]} {
		foreach bt [bots] {
                        if {[string tolower $whichbot] == [string tolower $bt]} {
				if {[onchan $bt $whichchan]} {
                                	putbot $bt "rpart $whichchan $handle"
                        	}
			}
                return 1
		}
	} elseif {[raflag $handle] && ([string tolower $botnick] == [string tolower $whichbot])} {
		channel remove $whichchan
		return 1
	} else {
		putserv "NOTICE $nick :\002\[\002\ReCo\002\]\002 You will have to authenticate first. Usage: /msg $botnick rauth <pwd>"		
	}
}

proc l_rpart_dcc {hand idx arg} {
	global botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set channel [lindex $arg 1]
	if {($whichbot == "") || ($channel == "")} {
		putdcc $idx "Usage: .rpart <bot> <channel>"
	} else {
		foreach bt [bots] {
			if {[string tolower $whichbot] == [string tolower $bt]} {
                               	putbot $bt "rpart $channel $hand"
			}
                }
	return 1
	}
}


### Part all ###

proc l_rpartall_pub {nick umask handle channel arg} {
	global botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichchan [lindex $arg 1]
	if {[string match "#*" $whichbot] || [string match "&*" $whichbot]} {set whichchan $whichbot}
	if {$whichchan == ""} {set whichchan $channel} 
	if {[raflag $handle] != 1} {
		putserv "NOTICE $nick :\002\[\002\ReCo\002\]\002 You will have to authenticate first. Usage: /msg $botnick rauth <pwd>"
	} else {	
		foreach bt [bots] {
			if {[onchan $bt $whichchan] && ([string tolower $bt] != [string tolower $whichbot])} {
				putbot $bt "rpart $whichchan $handle"
                	}
		}
		if {[string tolower $botnick] != [string tolower $whichbot]} {
			channel remove $whichchan
		}
	return 1
	}
}

proc l_rpartall_dcc {hand idx arg} {
	global botnick {botnet-nick}
	set channel [lindex $arg 0]
	set whichbot [lindex $arg 1]
	if {$channel == ""} {
		putdcc $idx "Usage: .partall <channel> \[bot to stay\]"
	} else {	
		foreach bt [bots] {
			if {[string tolower $bt] != [string tolower $whichbot]} {
				putbot $bt "rpart $channel $hand"
                	}
		}
		if {([string tolower $botnick] != [string tolower $whichbot]) && [validchan [string tolower $channel]]} {
			channel remove $channel
		}
	return 1
	}
}

proc r_rpart {nick idx arg} {
	set chan [lindex $arg 0]
	set doneby [lindex $arg 1]
	if {[l2flag $nick]} {
		if {[validchan $chan]} {
			channel remove $chan
		}
		putlog "\002\[\002\ReCo\002\]\002 rpart request by $doneby@$nick of $chan."
 	}
}

### authentication ###

proc rauth {nick uhost handle arg} {
	global botnick {botnet-nick} rc
	set pwd [lindex $arg 0]
	set online "0"
        foreach ch [channels] {
        	if {[handonchan $handle $ch]} {
                	set online "1"
                }
        }
	if {[validuser $handle]} {	
	    if {$pwd == ""} {
		    putserv "NOTICE $nick :$rc Usage: /msg $botnick rauth <pwd>"
	    } elseif {[raflag $handle]} {
		    putserv "NOTICE $nick :$rc You are already authenticated."
	    } elseif {!$online} {
		    putserv "NOTICE $nick :$rc I can't see you on any of my channels. Authentication aborted..."
	    } elseif {![passwdok $handle $pwd]} {
		    putserv "NOTICE $nick :$rc Authentication failed - wrong password."
		    putlog "$rc $nick / $uhost failed to authenticate."
	    } else {
		    setuser $handle XTRA rauth 1
		    putserv "NOTICE $nick :$rc Authentication successful!"
		    putlog "$rc Authentication of $handle successful."
	    }
	}
}

proc deauth_part {nick uhost handle channel} {
	set online "0"
	foreach ch [channels] {
   	    if {([string tolower $channel] != [string tolower $ch]) && ([handonchan $handle $ch] == 1)} {
		set online "1"
            }
	}
	if {[raflag $handle] && !$online} {
    	    setuser $handle XTRA rauth 0
            putlog "\002\[\002\ReCo\002\]\002 $handle partet $channel - deauthenticated."
        }
}

proc deauth_join {nick uhost handle channel} {
	set online "0"
	set botlistl ""
	foreach ch [channels] {
		if {$ch != $channel} {
			lappend botlistl $ch
		}
	}
	foreach ch $botlistl {
                        if {[handonchan $handle $ch]} {
                                set online "1"
                        }
        }
	if {[raflag $handle] && !$online} {
                        setuser $handle XTRA rauth 0
			putlog "\002\[\002\ReCo\002\]\002 $handle discovered on IRC again ($channel) - deauthenticated."
	}
}


proc deauth_signoff {nick uhost handle channel reason} {
	if {[raflag $handle]} {
		setuser $handle XTRA rauth 0
		putlog "\002\[\002\ReCo\002\]\002 $handle signed off - deauthenticated."
	}
}

### spy ###

proc l_rspy_on {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set channelfrom [lindex $arg 1]
	set channelto [lindex $arg 2]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {($whichbot == "") || ($channelfrom == "") || ($channelto == "")} {
		putdcc $idx "Usage: .rspy <bot> <channel to spy> <channel to deliver information>"
		return 0
	if {![validchan $channelto]} {
		putdcc $idx "I'm currently not $channelto - rspy aborted!"
		return 0
	}
	} else {
	    if {[bot_av $whichbot]} {
		putbot $whichbot "rspy $idx $channelfrom $channelto"
		return 1
	    } else {
		bot_nc $idx $whichbot
	    }
	}
}

proc l_rspystop {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rspystop <bot>"
		return 0
	} else {
	    if {[bot_av $whichbot]} {
		putbot $whichbot "rspystop $idx"
		return 1
	    } else {
		bot_nc $idx $whichbot
	    }
	}
}

proc l_rspyinfo {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rspyinfo <bot>"
		return 0
	} else {
	    if {[bot_av $whichbot]} {
		putbot $whichbot "rspyinfo $idx"
		return 1
	    } else {
		bot_nc $idx $whichbot
	    }
	}
}


proc l_spy_on {nick idx arg} {
    global l_channelfrom l_channelto
    set l_channelfrom [lindex $arg 0]
    set l_channelto [lindex $arg 1]
    set idx_req $idx
    spy_on $idx_req "0" 
}

proc l_spy_off {nick idx arg} {
    set idx_req $idx    
    spy_off $idx_req "0"
}

proc l_spy_info {nick idx arg} {
    set idx_req $idx
    spy_info $idx_req "0"
}

proc r_spy_on {nick idx arg} {
    global r_channelfrom r_channelto tobot
    set idx_req [lindex $arg 0]
    set r_channelfrom [lindex $arg 1]
    set r_channelto [lindex $arg 2]
    set tobot $nick
    if {![l2flag $nick]} {
	putbot $nick "na $idx_req rspy"
	putlog "$rc $doneby@$nick tried rspy on $whichuser."
    } else {
	spy_on $idx_req "1"
    }
}

proc r_spy_off {nick idx arg} {
    global tobot
    set idx_req [lindex $arg 0]
    set tobot $nick
    if {![l2flag $nick]} {
	putbot $nick "na $idx_req rspy"
	putlog "$rc $doneby@$nick tried rspy on $whichuser."
    } else {
	spy_off $idx_req "1"
    }
}

proc r_spy_info {nick idx arg} {
    global tobot
    set idx_req [lindex $arg 0]
    set tobot $nick
    if {![l2flag $nick]} {
	putbot $nick "na $idx_req rspy"
	putlog "$rc $doneby@$nick tried rspy on $whichuser."
    } else {
	spy_info $idx_req "1"
    }
}

proc spy_on {idx_req rmode} {
	global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto rc tobot botnick
	if {$rmode} {
	    set channelfrom $r_channelfrom
	    set channelto $r_channelto
	} else {
	    set channelfrom $l_channelfrom
	    set channelto $l_channelto
	}
	if {$l_spy_act || $r_spy_act} {
	    spy_off $idx_req $rmode
	}
	if {($channelfrom  == "") || ($channelto == "")} {
		putdcc $idx_req "Usage: .spy <channel to spy> <channel to put information>"
	} elseif {![validchan $channelfrom]} {
		if {!$rmode} {   
		    putdcc $idx_req "$rc I'm not on $channelfrom. Please make me join the channel."
		} else {
		    putbot $tobot "report $idx_req I'm not on $channelfrom. Please make me join the channel."
		}
	} elseif {![validchan $channelto]} {
                if {!$rmode} {
		    putdcc $idx_req "$rc I'm not on $channelto. Please make me join the channel."
		} else {
		    putbot $tobot "report $idx_req I'm not on $channelto. Please make me join the channel."
		}
	} else {
		if {$rmode} {
		    set r_spy_act "1"
		} else {
		    set l_spy_act "1"
		}
		if {!$rmode} {
		    putserv "PRIVMSG $channelto :$rc Spy mode active - now spying out $l_channelfrom." 
		} else {
		    putbot $tobot "sreport $channelto Spy mode active - now spying out $channelfrom. Information will be broadcasted by $botnick."
		}
		putlog "$rc Spying in $channelfrom, delivering information to $channelto."
		bind pubm - "$channelfrom*" spy_pubm
		bind join - "$channelfrom*" spy_join
		bind part - "$channelfrom*" spy_part
		bind sign - "$channelfrom*" spy_sign
		bind topc - "$channelfrom*" spy_topc
		bind kick - "$channelfrom*" spy_kick
		bind nick - "$channelfrom*" spy_nick
		bind mode - "$channelfrom*" spy_mode
		return 1
	}
}
	
proc spy_off {idx_req rmode} {
	global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto rc tobot botnick
	if {$rmode} {
	    set channelfrom $r_channelfrom
	    set channelto $r_channelto
	} else {
	    set channelfrom $l_channelfrom
	    set channelto $l_channelto
	}
	if {!$l_spy_act && !$rmode} {
	    putdcc $idx_req "$rc I'm not spying out any channel at the moment."
	} elseif {!$r_spy_act && $rmode} {
	    putbot $tobot "report $idx_req I'm not spying out any channel at the moment."
	} else {
	    if {$l_spy_act && !$rmode} {
		set l_spy_act "0"
		putlog "$rc Espionage on $channelfrom stopped..."
		putserv "PRIVMSG $channelto :$rc Spy mode deactivated. Stopped spying $channelfrom."
	    } elseif {$r_spy_act && $rmode} {
		set r_spy_act "0"
		putlog "$rc Remote espionage (to $tobot) on $channelfrom stopped..."
		putbot $tobot "sreport $channelto Spy mode deactivated. $botnick stopped spying $channelfrom." 
	    }
	    if {($rmode && ([string tolower $channelfrom] != [string tolower $r_channelfrom])) || (!$rmode && ([string tolower $channelfrom] != [string tolower $l_channelfrom]))} {
		unbind pubm - "$channelfrom*" spy_pubm
                unbind join - "$channelfrom*" spy_join
                unbind part - "$channelfrom*" spy_part
                unbind sign - "$channelfrom*" spy_sign
                unbind topc - "$channelfrom*" spy_topc
                unbind kick - "$channelfrom*" spy_kick
                unbind nick - "$channelfrom*" spy_nick
                unbind mode - "$channelfrom*" spy_mode
		return 1
	    }
	}
}

proc spy_info {idx_req rmode} {
	global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto rc tobot
	if {!$l_spy_act && !$rmode} {
	    putdcc $idx_req "$rc I'm not spying out any channel at the moment."
	} elseif {!$r_spy_act && $rmode} {
	    putbot $tobot "report $idx_req I'm not spying out any channel at the moment."
	} else {
	    if {$l_spy_act && !$rmode} {
		putdcc $idx_req "$rc I'm currently spying on $l_channelfrom and delivering information to $l_channelto."
	    } elseif {$r_spy_act && $rmode} {
		putbot $tobot "report $idx_req I'm currently spying on $r_channelfrom and delivering information to $r_channelto."
	    }
	}
	return 1
}

proc spy_pubm {nick uhost handle channel text} {
	global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
	if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {
		putserv "PRIVMSG $l_channelto :($nick:$channel) $text"
	} 
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel/$nick) $text"
	}
}

proc spy_join {nick uhost handle channel} {
        global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
        if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {   
		putserv "PRIVMSG $l_channelto :{$channel} $nick ($uhost) joined $channel."
    	}
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel) $nick ($uhost) joined $channel."
	}
}

proc spy_part {nick uhost handle channel} {
        global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
        if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {
                putserv "PRIVMSG $l_channelto :($channel) $nick ($uhost) left $channel."
    	}
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel) $nick ($uhost) left $channel."
	}
}

proc spy_sign {nick uhost handle channel reason} {
        global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
        if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {
                putserv "PRIVMSG $l_channelto :($channel) $nick left IRC: $reason"
    	} 
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel) $nick left IRC: $reason"
	}
}

proc spy_topc {nick uhost handle channel topic} {
        global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
        if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {
                putserv "PRIVMSG $l_channelto :($channel) Topic changed on $channel by $nick!$uhost: $topic"
    	}
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel) Topic changed on $channel by $nick!$uhost: $topic"
	}
}

proc spy_nick {nick uhost handle channel newnick} {
        global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
        if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {
                putserv "PRIVMSG $l_channelto :($channel) Nick change: $nick -> $newnick"
    	}
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel) Nick change: $nick -> $newnick"
	}
}

proc spy_kick {nick uhost handle channel kicked reason} {
        global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
        if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {
                putserv "PRIVMSG $l_channelto :($channel) $kicked![getchanhost $kicked $channel] kicked from $channel by $nick!$uhost: $reason"
    	}
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel) $kicked![getchanhost $kicked $channel] kicked from $channel by $nick!$uhost: $reason"
	}
}

proc spy_mode {nick uhost handle channel mchange} {
        global l_spy_act r_spy_act l_channelfrom r_channelfrom l_channelto r_channelto tobot botnick
        if {$l_spy_act && ([string tolower $l_channelfrom] == [string tolower $channel])} {
                putserv "PRIVMSG $l_channelto :($channel) mode change \"$mchange\" by $nick!$uhost"
    	}
	if {$r_spy_act && ([string tolower $r_channelfrom] == [string tolower $channel])} {
		putbot $tobot "sreport $r_channelto ($botnick:$channel) mode change \"$mchange\" by $nick!$uhost"
	}
}

### Remote Check ###

proc l_rcheck {hand idx arg} {
	global botnick {botnet-nick}
	foreach bt [bots] {
		if {[string tolower $bt] != [string tolower ${botnet-nick}]} {
			putbot $bt "rcheck $idx $hand"
            	}
	}
	return 1
}

proc r_rcheck {nick idx arg} {
	set idx_req [lindex $arg 0]
	set doneby [lindex $arg 1]
	if {[l1flag $nick] && [l2flag $nick] && [l3flag $nick]} {
		putbot $nick "rcheck_result $idx_req 1 1 1"
	} elseif {[l1flag $nick] && [l2flag $nick]} {
		putbot $nick "rcheck_result $idx_req 1 1 0"
	} elseif {[l1flag $nick] && [l3flag $nick]} {
		putbot $nick "rcheck_result $idx_req 1 0 1"
	} elseif {[l2flag $nick] && [l3flag $nick]} {
		putbot $nick "rcheck_result $idx_req 0 1 1"
	} elseif {[l1flag $nick]} {
		putbot $nick "rcheck_result $idx_req 1 0 0"
	} elseif {[l2flag $nick]} {
		putbot $nick "rcheck_result $idx_req 0 1 0" 
	} elseif {[l3flag $nick]} {
		putbot $nick "rcheck_result $idx_req 0 0 1" 
	}
	putlog "\002\[\002\ReCo\002\]\002 rcheck requested by $doneby@$nick."
}

proc l_rcheck_result {nick idx arg} {	
	global botnick {botnet-nick} rc
	set idx_req [lindex $arg 0]
	set rl1flag [lindex $arg 1]
	set rl2flag [lindex $arg 2]
	set rl3flag [lindex $arg 3]
	if {$rl1flag && $rl2flag && $rl3flag} {
		putdcc $idx_req "$rc ${botnet-nick}\'s access to $nick: Level 1, Level 2, Level 3."
	} elseif {$rl1flag && $rl2flag} {
		putdcc $idx_req "$rc ${botnet-nick}\'s access to $nick: Level 1, Level 2."
	} elseif {$rl1flag && $rl3flag} {
		putdcc $idx_req "$rc ${botnet-nick}\'s access to $nick: Level 1, Level 3."
	} elseif {$rl2flag && $rl3flag} {
		putdcc $idx_req "$rc ${botnet-nick}\'s access to $nick: Level 2, Level 3."
	} elseif {$rl1flag} {
		putdcc $idx_req "$rc ${botnet-nick}\'s access to $nick: Level 1."
	} elseif {$rl2flag} {
		putdcc $idx_req "$rc ${botnet-nick}\'s access to $nick: Level 2."
	} elseif {$rl3flag} {
		putdcc $idx_req "$rc ${botnet-nick}\'s access to $nick: Level 3."
	}
}


### Remote server jump ###

proc l_rjump {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichserver [lindex $arg 1]
	set jumpport [lindex $arg 2]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {($whichbot == "") || ($whichserver == "")} {
		putdcc $idx "Usage: .rjump <bot> <server> \[port\]"
		return 0
	} else {
	if {[bot_av $whichbot]} {
		putbot $whichbot "rjump $idx $whichserver $nick $jumpport"
		if {$jumpport != ""} {
		    append whichserver ":"
		    append whichserver $jumpport
		}
		return 1
	} else {
		bot_nc $idx $whichbot
		}
	}
}

proc r_rjump {nick idx arg} {
	global idx_req rc server
	set idx_req [lindex $arg 0]
	set whichserver [lindex $arg 1]
	set doneby [lindex $arg 2]
	set jumpport [lindex $arg 3]
	if {![l3flag $nick]} {
		putbot $nick "na $idx_req rjump"
		putlog "$rc $doneby@$nick tried rjump to $whichserver."
	} else {	
		set server_port [string last ":" $server]
		set oldserver [string range $server 0 [expr {$server_port - 1}]]
		set oldport [string range $server [expr {$server_port + 1}] end]
		jump $whichserver $jumpport
		putbot $nick "rjump_try $idx_req $whichserver $oldserver $jumpport"
		if {$oldserver == ""} {
		    putlog "$rc $doneby@$nick requested rjump. Attempting to jump to $whichserver."
		} else {    
		    if {$jumpport != ""} {
			putlog "$rc $doneby@$nick requested rjump. Attempting to jump from $oldserver:$oldport to $whichserver:$jumpport."
		    } else {
			putlog "$rc $doneby@$nick requested rjump. Attempting to jump from $oldserver:$oldport to $whichserver."
		    }
		}
		utimer 20 "l_rjump_check $idx_req $nick $oldserver $oldport $whichserver $doneby"
	}
}
	
proc l_rjump_check {idx nick oldserver oldport whichserver doneby} {
	    global rc server
	    if {$oldserver == ""} {
		jump
		putbot $nick "rjump_failed $idx $whichserver"
		putlog "$rc rjump by $doneby@$nick failed. Trying to connect to next server in my list..."
	    } else {
		if {$server == ""} {
		    jump $oldserver $oldport
		    putbot $nick "rjump_failed $idx $whichserver $oldserver"
		    putlog "$rc rjump by $doneby@$nick failed. Trying to reconnect to $oldserver..."
		} else {
		    putbot $nick "rjump_ok $idx $whichserver $oldserver"
		    putlog "$rc rjump by $doneby@$nick from $oldserver to $whichserver successful."
		}
	    }
}

proc l_rjump_try {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichserver [lindex $arg 1]
	set oldserver [lindex $arg 2]
	set jumpport [lindex $arg 3]
	if {$jumpport != ""} {
	    append whichserver ":"
	    append whichserver $jumpport
	}
	if {$oldserver == ""} {
	    putdcc $idx_req "$rc \{\002$nick\002\}: rjump request received and attempting to jump to $whichserver."
	} else {    
	    putdcc $idx_req "$rc \{\002$nick\002\}: rjump request received and attempting to jump from $oldserver to $whichserver."
	}
}

proc l_rjump_ok {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichserver [lindex $arg 1]
	set oldserver [lindex $arg 2]
	if {$oldserver == ""} {
	    putdcc $idx_req "$rc \{\002$nick\002\}: Executed rjump request successfully and jumped to $whichserver."
	} else {
	    putdcc $idx_req "$rc \{\002$nick\002\}: Executed rjump request successfully and jumped from $oldserver to $whichserver."
	}    
}

proc l_rjump_failed {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichserver [lindex $arg 1]
	set oldserver [lindex $arg 2]
	if {$oldserver == ""} {
	    putdcc $idx_req "$rc \{\002$nick\002\}: Failed jumping to $whichserver. I'm trying to connect to the next server in its list..."
	} else {
	    putdcc $idx_req "$rc \{\002$nick\002\}: Failed jumping from $oldserver to $whichserver. I'm trying to reconnect to $oldserver..."
	}
}

### Remote rehash ###

proc l_rrehash {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rrehash <bot>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "rrehash $idx $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "rrehash $idx $nick"
		return 1
	    }
	}
}

proc r_rrehash {nick idx arg} {
	global rc botnick {botnet-nick}
	set idx_req [lindex $arg 0]
	set doneby [lindex $arg 1]
	if {![l3flag $nick]} {
		putbot $nick "na $idx_req rrehash"
		putlog "$rc $doneby@$nick tried to execute rrehash."
	} else {
		putbot $nick "report $idx_req ${botnet-nick} rehashed."
    		putlog "$rc rrehash requested by $doneby@$nick"
		rehash
    		return 0
	}
}
	

### Remote restart ###

proc l_rrestart {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rrestart <bot>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "rrestart $idx $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "rrestart $idx $nick"
		return 1
	    }
	}
}

proc r_rrestart {nick idx arg} {
	global rc botnick {botnet-nick}
	set idx_req [lindex $arg 0]
	set doneby [lindex $arg 1]
	if {![l3flag $nick]} {
		putbot $nick "na $idx_req rrestart"
		putlog "$rc $doneby@$nick tried to execute rrestart."
	} else {
		putbot $nick "report $idx_req ${botnet-nick} restarted."
    		putlog "$rc rrestart requested by $doneby@$nick"
		restart
    		return 0
	}
}
	

### Remote die ###

proc l_rdie {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rdie <bot>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "rdie $idx $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "rdie $idx $nick"
		putlog "$rc $nick sent global rdie request. Hope it wasn't a mistake..."
		return 1
	    }
	}
}

proc r_rdie {nick idx arg} {
	global rc botnick {botnet-nick}
	set idx_req [lindex $arg 0]
	set doneby [lindex $arg 1]
	if {![l3flag $nick]} {
		putbot $nick "na $idx_req rdie"
		putlog "$rc $doneby@$nick tried to execute rdie."
	} else {
		putbot $nick "report $idx_req ${botnet-nick} shut down."
		die "rdie requested by $doneby@$nick"
    		return 0
	}
}

### Remote save ###

proc l_rsave {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rsave <bot>"
		return 0
	} else {
	    if {$whichbot != "*"} {
		if {[bot_av $whichbot]} {
		    putbot $whichbot "rsave $idx $nick"
		    return 1
		} else {
		    bot_nc $idx $whichbot
		}
	    } else {
		putallbots "rsave $idx $nick"
		return 1
	    }
	}
}

proc r_rsave {nick idx arg} {
	global rc botnick {botnet-nick}
	set idx_req [lindex $arg 0]
	set doneby [lindex $arg 1]
	if {![l1flag $nick]} {
		putbot $nick "na $idx_req rsave"
		putlog "$rc $doneby@$nick tried to execute rsave."
	} else {
		putbot $nick "report $idx_req ${botnet-nick} has saved its userfile."
    		putlog "$rc rsave requested by $doneby@$nick"
		save
    		return 0
	}
}



### rlevel ###
	
proc l_rlevel {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set slevels [lindex $arg 1]
	if {[string tolower $botnick] == [string tolower $whichbot]} {
		putdcc $idx "$rc Shouldn't I have complete access to myself? ;-)"
		return 0
	}
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rlevel <bot> <+/-><level(s)>"
		return 0
	}
	if {![validuser $whichbot]} {
                putdcc $idx "$rc I don't know $whichbot - rlevel aborted!"
		return 0
	}
	if {![matchattr $whichbot b]} {
                putdcc $idx "$rc $whichbot isn't a bot - rlevel aborted!"
		return 0
	} else {
	    set lflags [getlflags $whichbot]
	    if {$slevels == ""} {
		if {$lflags != ""} {
		    set levels ""
			for {set i 0} {$i < [string length $lflags]} {incr i} {
			    if {[string index $lflags $i] == 1} {
				append levels "Level 1"
			    } elseif {[string index $lflags $i] == 2} {
				append levels "Level 2"
			    } elseif {[string index $lflags $i] == 3} {
				append levels "Level 3"
			    }
			    if {[expr [string length $lflags] - 1] != $i} {
				append levels ", "
			    }
			}
			putdcc $idx "$rc $whichbot\'s access to me: $levels."      			
		    } else {
			putdcc $idx "$rc $whichbot doesn't have access to me."
		    }
		    return 1
	    }
	    if {[string match "\[+-\]*" $slevels]} {
		for {set i 1} {$i < [string length $slevels]} {incr i} {
		    if {![string match "*\[+-123\]*" [string index $slevels $i]]} {
			putdcc $idx "$rc Invalid access level(s) - rlevel aborted!"
			return 0
		    }
		}
	    } else {
		putdcc $idx "$rc Flags have to begin with '+' or '-'!"
		putdcc $idx "Usage: .rlevel <bot> <+/-><level(s)>"
		return 0
	    }
	    if {[string match "*1*" $lflags]} {
		set l1 "1"
	    } else {
		set l1 "0"
	    }
	    if {[string match "*2*" $lflags]} {
		set l2 "2"
	    } else {
		set l2 "0"
	    }
	    if {[string match "*3*" $lflags]} {
		set l3 "3"
	    } else {
		set l3 "0"
	    }
	    for {set i 0} {$i <= [string length $slevels]} {incr i} {
	        if {[string index $slevels $i] == "+"} {
		    set pm "1" 
		} elseif {[string index $slevels $i] == "-"} {
		    set pm "0"
		}
		if {([string index $slevels $i] == "1") && ($pm == 1)} {
		    set l1 "1"
		} elseif {([string index $slevels $i] == "1") && ($pm == 0)} {
		    set l1 "0"
		} elseif {([string index $slevels $i] == "2") && ($pm == 1)} {
		    set l2 "2"
		} elseif {([string index $slevels $i] == "2") && ($pm == 0)} {
		    set l2 "0"
		} elseif {([string index $slevels $i] == "3") && ($pm == 1)} {
		    set l3 "3"
		} elseif {([string index $slevels $i] == "3") && ($pm == 0)} {
		    set l3 "0"
		    }
	    }
	    set levelset ""
	    if {$l1 != "0"} {
	        append levelset $l1
	    }
	    if {$l2 != "0"} {
	        append levelset $l2
	    }
	    if {$l3 != "0"} {
	        append levelset $l3
	    }
	    if {$levelset != ""} {
	        setuser $whichbot XTRA rlevel $levelset
	        putlog "$rc $nick changed $whichbot\'s access level (bot access requested/now : $slevels/[getlflags $whichbot])."
	        return 1
	    } else {
	        setuser $whichbot XTRA rlevel $levelset
	        putlog "$rc $nick changed $whichbot\'s access level (bot access requested/now : $slevels/[getlflags $whichbot])."
	        return 1
	    }
     }		
}

### raccess ###

proc l_raccess {nick idx arg} {
    global rc botnick {botnet-nick}
    set blist ""
    foreach bt [userlist] {
	if {[matchattr $bt b]} {
	    lappend blist $bt
	}
    }
    foreach bt $blist {
	set levels ""
	if {[l1flag $bt]} {
	    append levels "Level 1"
	}
	if {[l2flag $bt]} {
	    if {$levels != ""} {
		append levels ", Level 2"
	    } else {
		append levels "Level 2"
	    }
	} 
	if {[l3flag $bt]} {
	    if {$levels != ""} {
		append levels ", Level 3"
	    } else {
		append levels "Level 3"
	    }
	}
	if {$levels != ""} {
	    putdcc $idx "$rc $bt\'s access to me: $levels." 
	}
    }
}


### rstatus ###

proc l_rstatus {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {$whichbot == ""} {
		putdcc $idx "Usage: .rstatus <bot>"
		return 0
	} else {
	    if {[bot_av $whichbot]} {
		putbot $whichbot "rstatus $idx $nick"
		return 1
	    } else {
		bot_nc $idx $whichbot
		}
	}		
}

proc r_rstatus {nick idx arg} {
	global rc rver botnick {botnet-nick} botname server version uptime
	set idx_req [lindex $arg 0]
	set doneby [lindex $arg 1]
	set chlist ""
	if {![l1flag $nick]} {
		putbot $nick "na $idx_req rstatus"
		putlog "$rc $doneby@$nick tried to request bot's status."
	} else {	
		foreach ch [channels] {
		    append chlist $ch
		    if {[botisop $ch]} {
			append chlist ":o:"
		    } else {
			append chlist ":n:"
		    }
		}
		if {$chlist == ""} {set chlist "no channels:"} 
		for {set i 0} {$i < [string length $rver]} {incr i} {
		    if {[string index $rver $i] == " "} {
			append ver ":"
		    } else {
			append ver [string index $rver $i]
		    }
		}
		append ver ":"
		if {$server != ""} {
		    set bbotnick $botnick
		    set bserver $server
		    set bbotname $botname
		} else {
		    set bbotnick "-"
		    set bserver "-"
		    set bbotname "-"
		}
		set buptime [expr [unixtime] - $uptime]
		putbot $nick "rstatus_result $idx_req $ver $bbotnick $bbotname $bserver $buptime $chlist $version"
	}
}
	
proc l_rstatus_ok {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set ver [lindex $arg 1]
	set rbotnick [lindex $arg 2]
	set rbotname [lindex $arg 3]
	set rserver [lindex $arg 4]
	set truptime [lindex $arg 5]
	set chlist [lindex $arg 6]
	set rversion [lindex $arg 7]
	set rversion2 [lrange $arg 9 end]
	set clist ""
	set opflag "1"
	for {set i 0} {$i < [string length $ver]} {incr i} {
	    if {[string index $ver $i] != ":"} {
		append tmp [string index $ver $i]
	    } else {
		lappend rver $tmp
		set tmp ""
	    }
	}
	set tmp ""
	for {set i 0} {$i < [string length $chlist]} {incr i} {
	    if {[string index $chlist $i] != ":"} {
		append tmp [string index $chlist $i]
	    } else {
		if {[string index $chlist [expr {$i + 1}]] == "o"} {
		    set tmp2 "@"
		    append tmp2 $tmp
		    set tmp $tmp2
		}
		if {$opflag == 0} {
		    set opflag "1"
		    set tmp ""
		} elseif {$opflag == 1} {
		    set opflag "0"
		    lappend clist $tmp
		    set tmp ""
		}
	    }
	}
	if {[expr {$truptime / 86400}] >= 1} {
	    set tmp [expr {abs($truptime / 86400)}]
	    append ruptime $tmp
	    if {$tmp == 1} {
		append ruptime " day "
	    } else {
		append ruptime " days "
	    }
	    set truptime [expr $truptime - [expr $tmp * 86400]]
	}
	if {[expr {$truptime / 3600}] >= 1} {
	    set tmp [expr {abs($truptime / 3600)}]
	    append ruptime $tmp
	    if {$tmp == 1} {
		append ruptime " hour "
	    } else {
		append ruptime " hours "
	    }
	    set truptime [expr $truptime - [expr $tmp * 3600]]
	}
	if {[expr {$truptime / 60}] >= 1} {
	    set tmp [expr {abs($truptime / 60)}]
	    append ruptime $tmp
	    if {$tmp == 1} {
		append ruptime " minute "
	    } else {
		append ruptime " minutes "
	    }
	    set truptime [expr $truptime - [expr $tmp * 60]]
	}
	if {$truptime != "" && $truptime != 0} {
	    append ruptime $truptime
	    if {$truptime == 1} {
		append ruptime " second"
	    } else {
		append  ruptime " seconds"
	    }
	}
	putdcc $idx_req "$rc Current status of $nick \[\002\ReCo $rver\002\]:"
	putdcc $idx_req "$rc -----------------------------------------------------"
	putdcc $idx_req "$rc Current Botnick: $rbotnick" 
	putdcc $idx_req "$rc Online as: $rbotname"
	putdcc $idx_req "$rc Server: $rserver"
	putdcc $idx_req "$rc Channel(s): $clist"
	putdcc $idx_req "$rc Up for: $ruptime"
	putdcc $idx_req "$rc Version: $rversion $rversion2"
}


### rchannel ###

proc l_rchannel {nick idx arg} {
	global rc botnick {botnet-nick} rchannel_act
	set whichbot [lindex $arg 0]
	set whichchannel [lindex $arg 1]
	if {([string tolower $whichbot] == "stop") && ([string tolower $whichchannel] == "stop")} {
		set rchannel_act "0"
		putdcc $idx "$rc rchannel request aborted."
		return 0
	}
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {$rchannel_act} {
		putdcc $idx "$rc Another rchannel request is still active. Please wait til it's done or type '.rchannel stop stop' to stop the current request."
		return 0
	}
	if {($whichbot == "") || ($whichchannel == "")} {
		putdcc $idx "Usage: .rchannel <bot> <channel>"
		return 0
	} else {
	    if {[bot_av $whichbot]} {
		putbot $whichbot "rchannel $idx $whichchannel $nick"
		return 1
	    } else {
		bot_nc $idx $whichbot
		}
	}		
}

proc r_rchannel {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichchannel [lindex $arg 1]
	set doneby [lindex $arg 2]
	set chlist ""
	if {![l1flag $nick]} {
		putbot $nick "na $idx_req rchannel"
		putlog "$rc $doneby@$nick tried to request chanlist of $whichchannel."
	} elseif {![validchan $whichchannel]} {
		putbot $nick "report $idx_req I don't monitor $whichchannel."
		putlog "$rc $doneby@$nick tried to request chanlist of $whichchannel."
	} else {	
		set ncount ""
		foreach nck [chanlist $whichchannel] {
		    set ncount [expr $ncount + 1]
		}
		set rchannel_id [string range [unixtime] 5 end]
		putbot $nick "rchannel_init $ncount $rchannel_id"
		foreach nck [chanlist $whichchannel] {
		    if {$nck != $whichchannel} {
			if {[isop $nck $whichchannel]} {
			    append chlist "o"
			    append chlist $nck
			    append chlist " "
			} else {
			    append chlist "n"
			    append chlist $nck
			    append chlist " "
			}
			append chlist [nick2hand $nck $whichchannel]
			append chlist " "
			append chlist [getchanjoin $nck $whichchannel]
			append chlist " "
			if {[matchattr $nck b]} {
			    append chlist "b "
			} elseif {[matchattr $nck n] || [matchattr $nck *|n $whichchannel]} {
			    append chlist "n "
			} elseif {[matchattr $nck m] || [matchattr $nck *|m $whichchannel]} {
			    append chlist "m "	
			} elseif {[matchattr $nck o] || [matchattr $nck *|o $whichchannel]} {
			    append chlist "o "
			} elseif {[matchattr $nck d] || [matchattr $nck *|d $whichchannel]} {
			    append chlist "d "
			} else {
			    append chlist "- "
			}
			append chlist [getchanidle $nck $whichchannel]
			append chlist " "
			append chlist [getchanhost $nck $whichchannel]
			append chlist " "
			append chlist " "
			putbot $nick "rchannel_result $idx_req $rchannel_id $whichchannel $chlist"
			set chlist ""
		    }
		}
	}
}

proc l_rchannel_init {nick idx arg} {
	global rchannel_act rchannel_entr rchannel_count rchannel_id
	set rchannel_act "1"
	set rchannel_entr [lindex $arg 0]
	set rchannel_count "1"
	set rchannel_id [lindex $arg 1]
}
	
proc l_rchannel_ok {nick idx arg} {
	global rc botnick {botnet-nick} botname rchannel_act rchannel_entr rchannel_count rchannel_id
	set idx_req [lindex $arg 0]
	set rchannel_id_got [lindex $arg 1]
	set whichchannel [lindex $arg 2]
	set centry [lrange $arg 3 end]
	if {($rchannel_id_got == $rchannel_id) && $rchannel_act} {
	    set c "1"
	    set tmp ""
	    set nck ""
	    set hand ""
	    set join ""
	    set idle ""
	    set flg ""
	    set umask ""
	    append centry " "
	    if {$rchannel_count == 1} {
		putdcc $idx_req "Channel $whichchannel"
		putdcc $idx_req "(n = owner, m = master, o = op, d = deop, b = bot)"
		putdcc $idx_req " NICKNAME        HANDLE    JOIN   IDLE  USER@HOST"
	    }
	    for {set i 0} {$i < [expr {[string length $centry] + 1}]} {incr i} {
		if {$c != "7"} {
		    if {[string index $centry $i] != " "} {
			append tmp [string index $centry $i]
		    } else {
			switch $c {
			    1 
				{
				if {[string index $tmp 0] == "o"} {
				    set nck "@"
				    append nck [string range $tmp 1 end]
				} else {
				    set nck " "
				    append nck [string range $tmp 1 end]
				}
				for {set j [string length $nck]} {$j < 16} {incr j} {
				    append nck " "
				}
				set tmp ""
				set c [expr {$c + 1}]
				}
			    2 
				{
				for {set j [string length $tmp]} {$j < 9} {incr j} {
				    append tmp " "
				}
				set hand $tmp
				set tmp ""
				set c [expr {$c + 1}]
				}
			    3 
				{
				if {$tmp == "0"} {
				    set join " --- "
				} else {
				    set join [strftime %R $tmp]
				} 
				set tmp ""
				set c [expr {$c + 1}]
				}
			    4	 
				{
				if {$tmp == "-"} {
				    set flg " "
				} else {
				    set flg $tmp
				}
				set tmp ""
				set c [expr {$c + 1}]
				}
			    5 
				{
				if {$tmp < 60} {
				    if {$tmp < 10} {
					set idle " "
				    } else {
					set idle ""
				    }
				    append idle $tmp
				    append idle "m"
				} elseif {([expr {$tmp >= 60}]) && ([expr {$tmp < 600}])} {
				    set idle " "
				    append idle [expr {abs($tmp / 60)}]
				    append idle "h"
				} elseif {[expr {$tmp >= 60}]} {
				    set idle [expr {abs($tmp / 60)}]
				    append idle "h"
				} elseif {([expr {$tmp >= 1440}]) && ([expr {$tmp < 14400}])} {
				    set idle " "
				    append idle [expr {abs($tmp / 1440)}]
				    append idle "d"
				} elseif {[expr {$tmp >= 1440}]} {
				    set idle [expr {abs($tmp / 1440)}]
				    append idle "d"
				}
				set tmp ""
				set c [expr {$c + 1}]
				}
			    6 
				{
				set j [string first "!" $botname]
				if {$tmp == [string range $botname [expr $j + 1] end]} {
				    set umask "<- it's me!"
				} else {
				    set umask " "
				    append umask $tmp
				}
			    	    set tmp ""
				    set c [expr {$c + 1}]
				}
			}
		    }
		} else {
		    putdcc $idx_req "$nck $hand $join $flg $idle $umask"
		    append tmp [string index $centry $i]
		    set c "1"
		    if {$rchannel_entr == $rchannel_count} {set rchannel_act "0"}
		    set rchannel_count [expr $rchannel_count + 1]
		}	
	    }
	}
}


### rchaninfo

proc l_rchaninfo {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichchannel [lindex $arg 1]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}
	if {($whichbot == "") || ($whichchannel == "")} {
		putdcc $idx "Usage: .rchaninfo <bot> <channel>"
		return 0
	} else {
	    if {[bot_av $whichbot]} {
		putbot $whichbot "rchaninfo $idx $whichchannel $nick"
		return 1
	    } else {
		bot_nc $idx $whichbot
		}
	}		
}

proc r_rchaninfo {nick idx arg} {
	global rc
	set idx_req [lindex $arg 0]
	set whichchannel [lindex $arg 1]
	set doneby [lindex $arg 2]
	if {![l1flag $nick]} {
		putbot $nick "na $idx_req rchaninfo"
		putlog "$rc $doneby@$nick tried to request chaninfo of $whichchannel."
	} elseif {![validchan $whichchannel]} {
		putbot $nick "report $idx_req I don't monitor $whichchannel."
		putlog "$rc $doneby@$nick tried to request chaninfo of $whichchannel."
	} else {	
		putbot $nick "rchaninfo_result start $idx_req $whichchannel [isdynamic $whichchannel]"
		for {set i 0} {$i < 2} {incr i} {
		    putbot $nick "rchaninfo_result $i $idx_req [lindex [channel info $whichchannel] $i]"
		}
		for {set i 12} {$i < 27} {incr i} {
		    putbot $nick "rchaninfo_result $i $idx_req [lindex [channel info $whichchannel] $i]"
		}
		for {set i 7} {$i < 12} {incr i} {
		    putbot $nick "rchaninfo_result $i $idx_req [lindex [channel info $whichchannel] $i]"
		}
	}
}

proc l_rchaninfo_ok {nick idx arg} {
    global rc chansets
    set type [lindex $arg 0]
    set idx_req [lindex $arg 1]
    set chandata [lrange $arg 2 end]
    if {$type == "start"} {
	set channel [lindex $arg 2]
	set chandata [lindex $arg 3]
	if {$chandata} {
	    set chantype "dynamic"
	} else {
	    set chantype "static"
	}
	putdcc $idx_req "$rc Current chaninfo of $chantype $channel from $nick:"  
	putdcc $idx_req "$rc -----------------------------------------------------"
    } elseif {$type == 0} {
	putdcc $idx_req "$rc Protect modes (chanmode): $chandata"
    } elseif {$type == 1} {
	if {!$chandata} {
	    set chandata "DONT!"
	}
	putdcc $idx_req "$rc Idle Kick after (idle-kick): $chandata" 	
    } elseif {$type > 11} {
	for {set j [string length $chandata]} {$j < 14} {incr j} {
	    append chandata " "
	}
	append chansets $chandata
	if {$type == 15} {
	    putdcc $idx_req "$rc Other modes:"
	    putdcc $idx_req "$rc   $chansets"
	    set chansets ""
	} elseif {$type == 19} {
	    putdcc $idx_req "$rc   $chansets"
	    set chansets ""
	} elseif {$type == 23} {
	    putdcc $idx_req "$rc   $chansets"
	    set chansets ""
	} elseif {$type == 26} {
	    putdcc $idx_req "$rc   $chansets"
	    set chansets ""
	}
    } elseif {$type == 7} {
	putdcc $idx_req "$rc Flood settings (times/sec):"
	putdcc $idx_req "$rc  chan : $chandata"
    } elseif {$type == 8} {
	putdcc $idx_req "$rc  CTCP : $chandata"
    } elseif {$type == 9} {
	putdcc $idx_req "$rc  join : $chandata"
    } elseif {$type == 10} {
	putdcc $idx_req "$rc  kick : $chandata"
    } elseif {$type == 11} {
	putdcc $idx_req "$rc  deop : $chandata"
    }    
}
    
### rchanset

# under development

### rcopy

proc l_rcopy {nick idx arg} {
	global rc botnick {botnet-nick}
	set whichbot [lindex $arg 0]
	set whichuser [lindex $arg 1]
	set umask [lindex $arg 2]
	if {[string tolower ${botnet-nick}] == [string tolower $whichbot]} {
		putdcc $idx "$rc Hey, I'm here. You don't need the remote control for me! ;-)"
		return 0
	}	
	if {($whichbot == "") || ($whichuser == "")} {
		putdcc $idx "Usage: .rcopy <bot> <handle to copy>"
		return 0
	} elseif {![validuser $whichuser]} {
		putdcc $idx "$rc Can't copy $whichuser - user doesn't exist."
		return 0
	} else {
	    if {[bot_av $whichbot]} {
		if {[matchattr $whichuser b]} {
		    set type "5"    
		    if {$whichbot == "*"} {
			putallbots "rcopy $idx $type $whichuser [lindex [getuser $whichuser hosts] 0] $nick [getuser $whichuser botaddr]"
		    } else {    
			putbot $whichbot "rcopy $idx $type $whichuser [lindex [getuser $whichuser hosts] 0] $nick [getuser $whichuser botaddr]"
		    }
		} else {
		    set type "0"
		    if {$whichbot == "*"} {
			putallbots "rcopy $idx $type $whichuser [lindex [getuser $whichuser hosts] 0] $nick"
		    } else {    
			putbot $whichbot "rcopy $idx $type $whichuser [lindex [getuser $whichuser hosts] 0] $nick"
		    }
		}
		set type "1"
		    set tmp "1"
		    foreach hmask [getuser $whichuser hosts] {
			if {$tmp != "1"} {
			    if {$whichbot == "*"} {
				putallbots "rcopy $idx $type $whichuser $hmask"
			    } else {
				putbot $whichbot "rcopy $idx $type $whichuser $hmask"
			    }
			}
			set tmp [expr $tmp + 1]
		    }
		set type "2"
		    if {$whichbot == "*"} {
		        putallbots "rcopy $idx $type $whichuser [getflags $whichuser *]"
		    } else {
		        putbot $whichbot "rcopy $idx $type $whichuser [getflags $whichuser *]"
		    }
		set type "3"
		    foreach ch [channels] {
			set tmp [expr {[string first "|" [chattr $whichuser $ch]] + 1}]
			if {$tmp != "-"} {
			    set chflags [string range [chattr $whichuser $ch] $tmp end]
			    if {($whichbot == "*") && ($chflags != "-")} {
			        putallbots "rcopy $idx $type $whichuser $ch $chflags"
			    } elseif {$chflags != "-"} {
			        putbot $whichbot "rcopy $idx $type $whichuser $ch $chflags"
			    }
			}
		    }
		if {$whichbot == "*"} {
		    putallbots "rcopy $idx 4 $whichuser $nick"
		} else {
		    putbot $whichbot "rcopy $idx 4 $whichuser $nick"
		}
	    } else {
		bot_nc $idx $whichbot
	    }
	}
}

proc r_rcopy {nick idx arg} {
	global rc uet
	set idx_req [lindex $arg 0]
	set type [lindex $arg 1]
	set whichuser [lindex $arg 2]
	set rcopy_data [lindex $arg 3]
	set rcopy_data2 [lindex $arg 4]
	set rcopy_data3 [lindex $arg 5]
	set botport [lindex $arg 6]
	set userport [lindex $arg 7]
	if {![l1flag $nick]} {
		putbot $nick "na $idx_req r+user"
		putlog "$rc $doneby@$nick tried rcopy of $whichuser ($umask)"
	} else {	
	    if {$type == "0"} {
		if {![validuser $whichuser]} {
		    set uet "0"
		    adduser $whichuser $rcopy_data
		    putlog "$rc Copy operation in progress.. receiving user '$whichuser' from $rcopy_data2@$nick."
		    return 0
		}
	    } elseif {$type == 1} {
		setuser $whichuser hosts $rcopy_data
	    } elseif {$type == 2} {
		chattr $whichuser $rcopy_data
	    } elseif {$type == 3} {
		set tmp "-|+"
		append tmp $rcopy_data2
		chattr $whichuser $tmp $rcopy_data
	    } elseif {$type == 4} {
	    	if {$uet} {
		    putbot $nick "uet $idx_req $whichuser"
		    return 0
		} else {
		    putlog "$rc User/bot '$whichuser' received from $rcopy_data@$nick."
	    	    putbot $nick "report $idx_req User/bot '$whichuser' received." 
		    set uet "1"
		}
	    } elseif {$type == 5} {
	    	if {![validuser $whichuser]} {
		    set uet "0"
		    append rcopy_data3 ":"
		    append rcopy_data3 $botport
		    append rcopy_data3 ":"
		    append rcopy_data3 $userport
		    addbot $whichuser $rcopy_data3
		    setuser $whichuser hosts $rcopy_data
		    putlog "$rc Copy operation in progress.. receiving bot '$whichuser' from $rcopy_data2@$nick."
		    return 0
		}
	    }
	}
}


### the rest

putlog "Remote Control $rver by LuNox loaded."